/*
    Copyright 1998-2003 Interplay Entertainment Corp.  All rights reserved.
*/

#ifndef _GLOBAL_H_DEFINED
#define _GLOBAL_H_DEFINED

/******************************************************************
   File Name: Global.h

   Purpose: This file contains defines for all of the global
            variables. This is an ordered list and needs to
            conform exactly to scripts list. All defines in here
            need to be prepended with GVAR_ as a naming
            convention.

   Created: November 11, 1997

   Changed by TeamX: 23.01.2007
******************************************************************/

// Reputation

#define GVAR_PLAYER_REPUTATION                  (0)
#define GVAR_CHILDKILLER_REPUTATION             (1)
#define GVAR_CHAMPION_REPUTATION                (2)
#define GVAR_BERSERKER_REPUTATION               (3)
#define GVAR_BAD_MONSTER                        (4)
#define GVAR_GOOD_MONSTER                       (5)
#define GVAR_REPUTATION_SLAVER                  (11)
#define GVAR_REPUTATION_SLAVE_OWNER             (12)

// Addiction

#define GVAR_NUKA_COLA_ADDICT                   (21)
#define GVAR_BUFF_OUT_ADDICT                    (22)
#define GVAR_MENTATS_ADDICT                     (23)
#define GVAR_PSYCHO_ADDICT                      (24)
#define GVAR_RADAWAY_ADDICT                     (25)
#define GVAR_ALCOHOL_ADDICT                     (26)
#define GVAR_ADDICT_TRAGIC                      (295)
#define GVAR_ADDICT_JET                         (296)

// Karma

#define GVAR_KARMA_HOLY_WARRIOR                 (37)
#define GVAR_KARMA_GUARDIAN_OF_THE_WASTES       (38)
#define GVAR_KARMA_SHIELD_OF_HOPE               (39)
#define GVAR_KARMA_DEFENDER                     (40)
#define GVAR_KARMA_WANDERER                     (41)
#define GVAR_KARMA_BETRAYER                     (42)
#define GVAR_KARMA_SWORD_OF_DESPAIR             (43)
#define GVAR_KARMA_SCOURGE_OF_THE_WASTES        (44)
#define GVAR_KARMA_DEMON_SPAWN                  (45)

// Town Reputation

//#define GVAR_TOWN_REP_ARROYO                    (47)  // ९ Area 00 !!! . GVAR_RATING_LEVEL !!!
#define GVAR_TOWN_REP_KLAMATH                   (48)  // ९ Area 02
#define GVAR_TOWN_REP_THE_DEN                   (49)  // ९ Area 01
#define GVAR_TOWN_REP_VAULT_CITY                (50)  // ९ Area 04
#define GVAR_TOWN_REP_GECKO                     (51)  // ९ Area 05
#define GVAR_TOWN_REP_MODOC                     (52)  // ९ Area 03
#define GVAR_TOWN_REP_SIERRA_BASE               (53)  // ९ Area 08
#define GVAR_TOWN_REP_BROKEN_HILLS              (54)  // ९ Area 06
#define GVAR_TOWN_REP_NEW_RENO                  (55)  // ९ Area 07
#define GVAR_TOWN_REP_REDDING                   (56)  // ९ Area 13
#define GVAR_TOWN_REP_NCR                       (57)  // ९ Area 10
#define GVAR_TOWN_REP_VAULT_13                  (59)  // ९ Area 11
#define GVAR_TOWN_REP_SAN_FRANCISCO             (61)  // ९ Area 14
#define GVAR_TOWN_REP_ENCLAVE                   (62)  // ९ Area 16
#define GVAR_TOWN_REP_ABBEY                     (63)  // ९ Area 17
#define GVAR_TOWN_REP_EPA                       (64)  // ९ Area 19
#define GVAR_TOWN_REP_PRIMITIVE_TRIBE           (65)  // ९ Area 18
#define GVAR_TOWN_REP_RAIDERS                   (66)  // ९ Area 25
#define GVAR_TOWN_REP_GHOST_FARM                (308) // ९ Area 20
#define GVAR_TOWN_REP_NAVARRO                   (628) // ९ Area 15

// Caravans

#define GVAR_CARAVAN_STATUS                     (269)
#define GVAR_CARAVAN_START                      (270)
#define GVAR_CARAVAN_END                        (271)
#define GVAR_CARAVAN_DRIVERS                    (272)
#define GVAR_CARAVAN_GUARDS                     (273)
#define GVAR_CARAVAN_CARTS                      (274)
#define GVAR_CARAVAN_ENCOUNTERS                 (275)
#define GVAR_CARAVAN_BRAHMIN                    (276)
#define GVAR_CARAVAN_MASTERS                    (277)
#define GVAR_CARAVAN_DRIVERS_TOTAL              (278)
#define GVAR_CARAVAN_GUARDS_TOTAL               (279)
#define GVAR_CARAVAN_CARTS_TOTAL                (280)
#define GVAR_CARAVAN_BRAHMIN_TOTAL              (281)
#define GVAR_CARAVAN_MASTERS_TOTAL              (282)
#define GVAR_CARAVAN_ENCOUNTERS_TOTAL           (283)

// Mysterious Stranger

#define GVAR_MYSTERIOUS_STRANGER                (352)
#define GVAR_MYSTERIOUS_STRANGER_LEVEL          (353)

// Special Encounters

#define GVAR_SPECIAL_ENCOUNTER_FLAGS            (323)
#define GVAR_RND_SALES_ENCOUNTER                (360)
#define GVAR_HOLY_GRENADE                       (372)
#define GVAR_SPECIAL_ENCOUNTER_BRIDGE           (605)
#define GVAR_SPECIAL_ENCOUNTER_HOLY2            (606)
#define GVAR_SPECIAL_ENCOUNTER_TOXIC            (607)
#define GVAR_SPECIAL_ENCOUNTER_PARIAH           (608)
#define GVAR_SPECIAL_ENCOUNTER_BRAHMIN          (609)
#define GVAR_SPECIAL_ENCOUNTER_WHALE            (610)
#define GVAR_SPECIAL_ENCOUNTER_HEAD             (611)
#define GVAR_SPECIAL_ENCOUNTER_SHUTTLE          (612)
#define GVAR_SPECIAL_ENCOUNTER_GUARDIAN         (613)
#define GVAR_SPECIAL_ENCOUNTER_HOLY1            (614)
#define GVAR_SPECIAL_ENCOUNTER_WOODSMAN         (615)
#define GVAR_SPECIAL_ENCOUNTER_CAFE             (617)
#define GVAR_SPECIAL_ENCOUNTER_UNWASHED         (620)

// Party

#define GVAR_PARTY_CHILDKILLER                  (289)
#define GVAR_PARTY_NO_FOLLOW                    (398)
#define GVAR_PARTY_MEMBERS_HIDDEN               (632)

// Car

#define GVAR_PLAYER_GOT_CAR                     (18)
#define GVAR_SUPER_CAR                          (379)
#define GVAR_CAR_BLOWER                         (439)
#define GVAR_CAR_UPGRADE_FUEL_CELL_REGULATOR    (453)
#define GVAR_NEW_RENO_CAR_UPGRADE               (455)
#define GVAR_NEW_RENO_SUPER_CAR                 (456)
#define GVAR_DEN_CAR_PART_PIP                   (550)
#define GVAR_LEFT_CAR_AT_RAIDERS                (586)
#define GVAR_RAIDERS_CAR_ELEVATION              (587)
#define GVAR_CAR_PLACED_TILE                    (633)

// Engine

#define GVAR_LOAD_MAP_INDEX                     (27)
#define GVAR_RUNNING_BURNING_GUY                (28)
#define GVAR_MAP_EXIT_TILE                      (46)
#define GVAR_MAP_NEXT_TILE                      (67)
#define GVAR_PATCH_INVAIDITATOR                 (695)

// Dude

#define GVAR_DUDE_STOMACH                       (104)
#define GVAR_MUTATE                             (132)
#define GVAR_MUTATE_WHEN                        (133)
#define GVAR_HAVE_MUTATED                       (192)
#define GVAR_MUTATE_STAGE                       (193)
#define GVAR_PLAYER_SEX_LEVEL                   (194)
#define GVAR_SEX_COUNTER                        (358)

// Fallout2

#define GVAR_FALLOUT_2                          (494)
#define GVAR_PIPBOY_TOUR_GUIDE                  (404)
#define GVAR_PIPBOY_CREDITS                     (405)

// Merc Reputation

#define GVAR_REP_ENEMY                          (6)
#define GVAR_REP_TREATOR                        (7)
#define GVAR_REP_SUSPICIOUS                     (8)
#define GVAR_REP_GREENHORN                      (9)
#define GVAR_REP_PROMISING                      (10)
#define GVAR_REP_ADVANCED                       (13)
#define GVAR_REP_SPECIALIST                     (14)
#define GVAR_REP_PROFESSIONAL                   (15)
#define GVAR_REP_EXAMPLE                        (16)
#define GVAR_REP_PRIDE                          (17)
#define GVAR_REP_LEGEND                         (19)

#define GVAR_RATING_POINTS                      (20)
#define GVAR_RATING_LEVEL                       (47) // ᯮ GVAR 47 -- ९  ମ!

#define GVAR_DUDE_IS_MERC                       (30)

// GVAR_ENEMY_TOWN

#define GVAR_ENEMY_HARMONT                      (29)

// Harmont GVARs

#define GVAR_BARBRIGE_STATUS                    (31)
#define GVAR_FIRST_QUEST                        (32)
#define GVAR_FQMERCS_COUNT                      (33) // := 2
#define GVAR_ERNESTO_STATUS                     (34)
#define GVAR_HARMONT_FLAGS                      (35)
#define GVAR_MAX_STATUS                         (36)
#define GVAR_ASH_STATUS                         (68)




#define GVAR_FQ_FLAGS                           (75) // ;   ࢮ (09.05.07 Sokil)
#define GVAR_FQ_HOLODISK                        (76) // ;   樨(10.06.07 Sokil)

/******************************************************************
    Variable States
******************************************************************/

#define KNOWLEDGE_NONE                      (0)
#define KNOWLEDGE_LEARNING                  (1)
#define KNOWLEDGE_OBTAINED                  (2)

#define QUEST_NONE                          (0)
#define QUEST_KNOWN                         (1)
#define QUEST_DECLINED                      (2)
#define QUEST_INACTIVE                      (3)
#define QUEST_ACCEPTED                      (4)
#define QUEST_PAST_PART_1                   (5)
#define QUEST_PAST_PART_2                   (6)
#define QUEST_COMPLETED                     (7)
#define QUEST_DEFAULT_SOLVE                 (8)

#define PERSON_KNOWN                        bit_1
#define PERSON_ATTACKED                     bit_2
#define PERSON_KILLED                       bit_3
#define PERSON_ASSASSINATED                 bit_4
#define PERSON_IN_PARTY                     bit_5
#define PERSON_SPOKEN_TO                    bit_6
#define PERSON_SPOKEN_TO_SPECIAL            bit_7
#define PERSON_SPECIAL                      bit_8
#define PERSON_SPECIAL_2                    bit_9
#define PERSON_DEAD                         bit_10
#define PERSON_WARNED                       bit_11
#define PERSON_SEX                          bit_12

// Caravan States
// GVAR_CARAVAN_STATUS
#define CARAVAN_STATUS_NONE                 (0)
#define CARAVAN_STATUS_WAITING              (1)
#define CARAVAN_STATUS_ON_JOB               (2)
#define CARAVAN_STATUS_SUCCESS              (3)
#define CARAVAN_STATUS_PARTIAL_SUCCESS      (4)
#define CARAVAN_STATUS_FAILED               (5)
#define CARAVAN_STATUS_TOTAL_FAILED         (6)
#define CARAVAN_STATUS_THEFT                (7)
#define CARAVAN_STATUS_ABANDONED            (8)

// GVAR_CARAVAN_START
// GVAR_CARAVAN_END
#define CARAVAN_NONE                        (0)
#define CARAVAN_REDDING                     (1)
#define CARAVAN_VAULT_CITY                  (2)
#define CARAVAN_NEW_RENO                    (3)
#define CARAVAN_NCR                         (4)
#define CARAVAN_THE_DEN                     (5)
#define CARAVAN_BROKEN_HILLS                (6)
#define CARAVAN_GECKO                       (7)
#define CARAVAN_SAN_FRANCISCO               (8)
#define CARAVAN_MODOC                       (9)
#define CARAVAN_KLAMATH                     (10)
#define CARAVAN_ARROYO                      (11)
#define CARAVAN_PRIMITIVE_TRIBE             (12)

// GVAR_FIRST_QUEST
#define FIRST_NONE                          (0)
#define FIRST_ACCEPTED                      (1)
#define FIRST_COMPLETED                     (2)
#define FIRST_ESCAPED                       (3)

/******************************************************************
      SPECIAL MACROS FOR SETTING SHARED FLAGS
 ******************************************************************/
// Mysterious Stranger Flags
#define STRANGER_DEAD           bit_1
#define STRANGER_GENDER         bit_2
#define STRANGER_FEMALE         bit_3
#define get_stranger_flag(x)    (global_var(GVAR_MYSTERIOUS_STRANGER) bwand x)
#define set_stranger_flag(x)    set_global_var(GVAR_MYSTERIOUS_STRANGER, global_var(GVAR_MYSTERIOUS_STRANGER) bwor x)

/******************************************************************/



/********************************************************************
*******************   Game time Limits   ****************************
********************************************************************/

#ifndef TIME_LIMIT_1
#define TIME_LIMIT_1                        (90)
#endif
#ifndef TIME_LIMIT_2
#define TIME_LIMIT_2                        (180)
#endif
#ifndef TIME_LIMIT_3
#define TIME_LIMIT_3                        (270)
#endif
#ifndef TIME_LIMIT_4
#define TIME_LIMIT_4                        (360)
#endif

#define reached_tl_1                        (GAME_TIME_IN_DAYS >= TIME_LIMIT_1)
#define reached_tl_2                        (GAME_TIME_IN_DAYS >= TIME_LIMIT_2)
#define reached_tl_3                        (GAME_TIME_IN_DAYS >= TIME_LIMIT_3)
#define reached_tl_4                        (GAME_TIME_IN_DAYS >= TIME_LIMIT_4)

#endif // _GLOBAL_H_DEFINED